From f563d019796d8b536d1be0acfd31a47e8c6a232c Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:35:08 +0000
Subject: [PATCH 951/1001] Use functions for widget parameter validators


---

diff --git a/hubs/tests/test_widget_validators.py b/hubs/tests/test_widget_validators.py
index ba0c2b8..d421aa5 100644
--- a/hubs/tests/test_widget_validators.py
+++ b/hubs/tests/test_widget_validators.py
@@ -10,50 +10,50 @@ from hubs.tests import APPTest
 class ValidatorsTest(APPTest):
 
     def test_required(self):
-        self.assertRaises(ValueError, validators.Required.from_string, "")
+        self.assertRaises(ValueError, validators.Required, "")
 
     def test_text(self):
-        self.assertEqual(validators.Text.from_string("\xe9"), "\xe9")
+        self.assertEqual(validators.Text("\xe9"), "\xe9")
 
     def test_integer(self):
-        self.assertEqual(validators.Integer.from_string("1"), 1)
-        self.assertRaises(ValueError, validators.Integer.from_string, "text")
+        self.assertEqual(validators.Integer("1"), 1)
+        self.assertRaises(ValueError, validators.Integer, "text")
 
     @unittest.skip("Not implemented yet")
     def test_link(self):
         value = '<a href="somewhere">dummy</a>'
         self.assertEqual(validators.Link.from_string(value), value)
-        self.assertRaises(ValueError, validators.Link.from_string, "text")
+        self.assertRaises(ValueError, validators.Link, "text")
 
     def test_username(self):
-        self.assertEqual(validators.Username.from_string("ralph"), "ralph")
+        self.assertEqual(validators.Username("ralph"), "ralph")
         self.assertRaises(
-            ValueError, validators.Username.from_string, "nobody")
+            ValueError, validators.Username, "nobody")
 
     @unittest.skip("Not implemented yet")
     def test_github_organization(self):
         self.assertEqual(
-            validators.GithubOrganization.from_string("fedora-infra"),
+            validators.GithubOrganization("fedora-infra"),
             "fedora-infra")
         self.assertRaises(
             ValueError,
-            validators.GithubOrganization.from_string,
+            validators.GithubOrganization,
             "something-that-does-not-exist")
 
     @unittest.skip("Not implemented yet")
     def test_github_repo(self):
         self.assertEqual(
-            validators.GithubRepo.from_string("fedmsg"), "fedmsg")
-        self.assertRaises(ValueError, validators.GithubRepo.from_string,
+            validators.GithubRepo("fedmsg"), "fedmsg")
+        self.assertRaises(ValueError, validators.GithubRepo,
                           "something-that-does-not-exist")
 
     def test_fmncontext(self):
-        self.assertEqual(validators.FMNContext.from_string("email"), "email")
+        self.assertEqual(validators.FMNContext("email"), "email")
         self.assertRaises(
-            ValueError, validators.FMNContext.from_string, "dummy")
+            ValueError, validators.FMNContext, "dummy")
 
     def test_pagure_repo(self):
         self.assertEqual(
-            validators.PagureRepo.from_string("fedora-hubs"), "fedora-hubs")
-        self.assertRaises(ValueError, validators.PagureRepo.from_string,
+            validators.PagureRepo("fedora-hubs"), "fedora-hubs")
+        self.assertRaises(ValueError, validators.PagureRepo,
                           "something-that-does-not-exist")
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 7f35b37..b562662 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -9,7 +9,6 @@ import six
 from importlib import import_module
 from .caching import CachedFunction
 from .view import WidgetView
-from .validators import Validator
 
 
 log = logging.getLogger(__name__)
@@ -25,18 +24,17 @@ class WidgetParameter(object):
     :py:meth:`~Widget.get_parameters` method.
 
     The value of the parameter is stored in the database as the value returned
-    by the validator's :py:meth:`from_string` method.  It can thus be a string,
-    an integer, a list, a dict, or any JSON-serializable value.
+    by the validator's call.  It can thus be a string, an integer, a list, a
+    dict, or any JSON-serializable value.
 
     Attributes:
         name (str): The name of the parameter.
         label (str): A humanized name of the parameter, which will be shown in
             the UI.
         default: The default value if this parameter is not set.
-        validator (hubs.widgets.validators.Validator): A validator subclass
-            that will be used to convert the parameter value to and from
-            string, raising an exception if it is invalid. This attribute
-            points to the validator subclass, not an instance of the class.
+        validator (callable): A validator function that will be used to convert
+            the parameter value to a JSON-serializable value, raising an
+            exception if it is invalid.
         help (str): A help text that will be shown in the UI.
     """
 
@@ -49,7 +47,7 @@ class WidgetParameter(object):
             raise TypeError("Invalid attribute: %s" % name)
         # Set default validator
         if self.validator is None:
-            self.validator = Validator
+            self.validator = lambda x: x
 
 
 class Widget(object):
diff --git a/hubs/widgets/validators.py b/hubs/widgets/validators.py
index bf05a53..f8c5b8f 100644
--- a/hubs/widgets/validators.py
+++ b/hubs/widgets/validators.py
@@ -1,82 +1,50 @@
+"""
+Validate and convert the value of widget parameters.
+
+Validators are used to validate and convert
+:py:class:`~hubs.widgets.base.WidgetParameter` values. They will raise a
+``ValueError`` exception if the value is invalid.
+
+A validator is a function that will receive the value as unique argument, and
+will return the validated value.
+"""
+
 from __future__ import unicode_literals
 
 import flask
 import hubs.models
 import kitchen.text.converters
 import requests
+import six
 
 
-class Validator(object):
-    """Convert widget parameters to and from string, and validate their value.
-
-    Validators are used to convert
-    :py:class:`~hubs.widgets.base.WidgetParameter` values to and from string.
-    They will raise an exception if the value is invalid.
-
-    A validator is a subclass of the :py:class:`Validator` class and implements
-    two class methods: :py:meth:`from_string` and :py:meth:`to_string`.
-    """
-
-    @classmethod
-    def from_string(cls, value):
-        """Convert the value from a string to a JSON-serializable value.
-
-        The result of this function will be stored in the database for widget
-        parameters.
-
-        Raises:
-            ValueError: The value is invalid.
-        """
-        if value is None:
-            return ""
-        return value
-
-    @classmethod
-    def to_string(cls, value):
-        """Convert the value to a string.
-
-        The result of this function will be used in the widget configuration
-        form fields.
-        """
-        return value
-
-
-class Required(Validator):
+def Required(value):
     """Raises an error if the value is ``False``-like."""
-
-    @classmethod
-    def from_string(cls, value):
-        if not bool(value):
-            raise ValueError("the parameter is required")
-        return value
+    if not bool(value):
+        raise ValueError("the parameter is required")
+    # if callable(value):
+    #     # Act as a decorator
+    #     return lambda v: Required(value(v))
+    return value
 
 
-class Text(Validator):
+def Text(value):
     """Raises an error if the value can't be converted to unicode."""
+    return kitchen.text.converters.to_unicode(value)
 
-    @classmethod
-    def from_string(cls, value):
-        return kitchen.text.converters.to_unicode(value)
 
-
-class Integer(Validator):
+def Integer(value):
     """Raises an error if the value can't be converted to an integer."""
-
-    @classmethod
-    def from_string(cls, value):
-        return int(value)
+    return int(value)
 
 
-class Link(Validator):
+def Link(value):
     """Raises an error if the value doesn't look like a link."""
-
-    @classmethod
-    def from_string(cls, value):
-        # TODO -- verify that this is actually a link
-        return value
+    # TODO -- verify that this is actually a link
+    return value
 
 
-class Username(Validator):
+def Username(value):
     """Raises an error if the value isn't an existing username.
 
     There must be a corresponding :py:class:`~hubs.models.User` record.
@@ -84,77 +52,55 @@ class Username(Validator):
     This validator does not return the User instance because it is not
     JSON-serializable, it returns the username unchanged.
     """
-
-    @classmethod
-    def from_string(cls, value):
-        if hubs.models.User.by_username(value) is not None:
-            return value
-        raise ValueError('Invalid username')
-
-    @classmethod
-    def to_string(cls, value):
-        if value is None and flask.g.auth.logged_in:
-            return flask.g.user.username
+    if value is None and flask.g.auth.logged_in:
+        return flask.g.user.username
+    if hubs.models.User.by_username(value) is not None:
         return value
+    raise ValueError('Invalid username')
 
 
-class GithubOrganization(Validator):
+def GithubOrganization(value):
     """Fails if the Github organization name does not exist."""
-
-    @classmethod
-    def from_string(cls, value):
-        # TODO -- implement this.
-        return value
+    # TODO -- implement this.
+    return value
 
 
-class GithubRepo(Validator):
+def GithubRepo(value):
     """Fails if the Github repository name does not exist."""
-
-    @classmethod
-    def from_string(cls, value):
-        # TODO -- implement this.
-        return value
+    # TODO -- implement this.
+    return value
 
 
-class FMNContext(Validator):
+def FMNContext(value):
     """Fails if the value is not a valid FMN context name."""
-
-    @classmethod
-    def from_string(cls, value):
-        # TODO get this from the fedmsg config.
-        if value in ['irc', 'email', 'android', 'desktop', 'hubs']:
-            return value
-        raise ValueError('Invalid FMN context')
+    # TODO get this from the fedmsg config.
+    if value in ['irc', 'email', 'android', 'desktop', 'hubs']:
+        return value
+    raise ValueError('Invalid FMN context')
 
 
-class PagureRepo(Validator):
+def PagureRepo(value):
     """Fails if the Pagure repository name does not exist."""
-
-    @classmethod
-    def from_string(cls, value):
-        response = requests.get("https://pagure.io/%s" % value, timeout=5)
-        if response.status_code == 200:
-            return value
-        raise ValueError('Invalid pagure repo')
+    response = requests.get("https://pagure.io/%s" % value, timeout=5)
+    if response.status_code == 200:
+        return value
+    raise ValueError('Invalid pagure repo')
 
 
-class CommaSeparatedList(Validator):
-    """Fails if the value isn't a comma-separated list.
+def CommaSeparatedList(value):
+    """Fails if the value isn't a list.
 
-    The value will be converted to a Python list. If there is no comma in the
-    original value, it will produce a list with a single element. Whitespaces
-    will be stripped from the elements, so spaces are allowed around the
-    commas.
+    If the value is a string, list, it will be interpreted as a comma-separated
+    list and converted to a Python list. If there is no comma in the original
+    value, it will produce a list with a single element. Whitespaces will be
+    stripped from the elements, so spaces are allowed around the commas.
     """
-
-    @classmethod
-    def from_string(cls, value):
+    if not value:
+        return []
+    if isinstance(value, six.string_types):
         return [
             elem.strip() for elem in value.split(",") if elem.strip()
             ]
-
-    @classmethod
-    def to_string(cls, value):
-        if not value:
-            return ""
-        return ", ".join(value)
+    if not isinstance(value, list):
+        raise ValueError("Expected a list")
+    return value

